/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.email.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="EMAIL_VORGANG.CountEmailLayout",
     query="select count(o) from EmailVorgang o where o.emailLayout=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="EMAIL_VORGANG.CountEmailVorlage",
     query="select count(o) from EmailVorgang o where o.emailVorlage=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "EMAIL_VORGANG")
// @javax.persistence.IdClass(EmailVorgangPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class EmailVorgang
extends AbstractEmailVorgang
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public EmailVorgang() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public EmailVorgang(EmailVorgang original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "email_vorgang_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "EmailVorgang")
    @javax.persistence.TableGenerator(name = "EmailVorgang", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "EmailVorgang", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient EmailVorgangPK pkCache;

  @Override
  public EmailVorgangPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new EmailVorgangPK(getId());
    }

    return pkCache;
  }

  public static <E extends EmailVorgang> java.util.Map<EmailVorgangPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<EmailVorgangPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends EmailVorgang> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;


  public void resetAttributeChanged() {
        hasChangedBenutzerkennung = false;
          hasChangedBetreff = false;
          hasChangedErstellungszeitpunkt = false;
          hasChangedInhalt = false;
          hasChangedStatus = false;
          hasChangedTyp = false;
  
      hasChangedEmailLayout = false;
        hasChangedEmailVorlage = false;
        hasChangedWahltermin = false;
        hasChangedWahl = false;
  

        
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BENUTZERKENNUNG", nullable = EmailVorgangConstants.BENUTZERKENNUNG_NULLABLE, length=EmailVorgangConstants.BENUTZERKENNUNG_MAX_LENGTH)
        
  protected java.lang.String benutzerkennung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBenutzerkennung = false;

  public boolean hasChangedBenutzerkennung(){
    return hasChangedBenutzerkennung;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.BENUTZERKENNUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBenutzerkennung() {
        return benutzerkennung;
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.BENUTZERKENNUNG
   *
   * @param benutzerkennung
   */
  @Override   public void setBenutzerkennung(@javax.annotation.Nullable  java.lang.String benutzerkennung) {

       resetTkCache();
                  
                          java.lang.String benutzerkennungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(benutzerkennung, EmailVorgangConstants.BENUTZERKENNUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.benutzerkennung
      , benutzerkennungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBenutzerkennung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("benutzerkennung");
      }


      

       this.benutzerkennung = benutzerkennungInternal;

         }

        
      @javax.persistence.Column(name = "BETREFF", nullable = EmailVorgangConstants.BETREFF_NULLABLE, length=EmailVorgangConstants.BETREFF_MAX_LENGTH)
        
  protected java.lang.String betreff =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBetreff = false;

  public boolean hasChangedBetreff(){
    return hasChangedBetreff;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.BETREFF
   */
    @Override   public  java.lang.String getBetreff() {
        return betreff;
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.BETREFF
   *
   * @param betreff
   */
  @Override   public void setBetreff( java.lang.String betreff) {

       resetTkCache();
                  
                          java.lang.String betreffInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(betreff, EmailVorgangConstants.BETREFF_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.betreff
      , betreffInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBetreff |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("betreff");
      }


      

       this.betreff = betreffInternal;

         }

        
      @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "ERSTELLUNGSZEITPUNKT", nullable = EmailVorgangConstants.ERSTELLUNGSZEITPUNKT_NULLABLE, precision=EmailVorgangConstants.ERSTELLUNGSZEITPUNKT_PRECISION)
    
  protected java.util.Date erstellungszeitpunkt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedErstellungszeitpunkt = false;

  public boolean hasChangedErstellungszeitpunkt(){
    return hasChangedErstellungszeitpunkt;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.ERSTELLUNGSZEITPUNKT
   */
    @Override   public  java.util.Date getErstellungszeitpunkt() {
              if (erstellungszeitpunkt == null){
            return null;
          } else {
                          return erstellungszeitpunkt;
          }
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.ERSTELLUNGSZEITPUNKT
   *
   * @param erstellungszeitpunkt
   */
  @Override   public void setErstellungszeitpunkt( java.util.Date erstellungszeitpunkt) {

       resetTkCache();
                  java.util.Date erstellungszeitpunktInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(erstellungszeitpunkt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.erstellungszeitpunkt
      , erstellungszeitpunktInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedErstellungszeitpunkt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("erstellungszeitpunkt");
      }


      

       this.erstellungszeitpunkt = erstellungszeitpunktInternal;

         }

        
  @javax.persistence.Basic(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.Lob
      @javax.persistence.Column(name = "INHALT", nullable = EmailVorgangConstants.INHALT_NULLABLE, length = Integer.MAX_VALUE)
    
  protected java.lang.String inhalt =  null;

  @javax.persistence.Transient
  protected boolean hasChangedInhalt = false;

  public boolean hasChangedInhalt(){
    return hasChangedInhalt;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.INHALT
   *
   * (LAZY LOADING)
   */
    @Override   public  java.lang.String getInhalt() {
        return inhalt;
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.INHALT
   *
   * @param inhalt
   */
  @Override   public void setInhalt( java.lang.String inhalt) {

       resetTkCache();
                  java.lang.String inhaltInternal = org.apache.commons.lang3.StringUtils.trimToNull(inhalt);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.inhalt
      , inhaltInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedInhalt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("inhalt");
      }


      

       this.inhalt = inhaltInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "STATUS", nullable = EmailVorgangConstants.STATUS_NULLABLE)
    
  protected de.ivu.elect.business.email.entity.EmailVorgangStatusType status =  de.ivu.elect.business.email.entity.EmailVorgangStatusType.WIRD_VERSENDET;

  @javax.persistence.Transient
  protected boolean hasChangedStatus = false;

  public boolean hasChangedStatus(){
    return hasChangedStatus;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.STATUS
   */
    @Override   public  de.ivu.elect.business.email.entity.EmailVorgangStatusType getStatus() {
        return status;
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.STATUS
   *
   * @param status
   */
  @Override   public void setStatus( de.ivu.elect.business.email.entity.EmailVorgangStatusType status) {

       resetTkCache();
                  de.ivu.elect.business.email.entity.EmailVorgangStatusType statusInternal = status;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.status
      , statusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("status");
      }


      

       this.status = statusInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "TYP", nullable = EmailVorgangConstants.TYP_NULLABLE)
    
  protected de.ivu.elect.business.email.entity.EmailVorgangType typ =  null;

  @javax.persistence.Transient
  protected boolean hasChangedTyp = false;

  public boolean hasChangedTyp(){
    return hasChangedTyp;
  }
  
  /**
   * 
   *
   * getter for EMAIL_VORGANG.TYP
   */
    @Override   public  de.ivu.elect.business.email.entity.EmailVorgangType getTyp() {
        return typ;
      }

  /**
   * 
   *
   * setter for EMAIL_VORGANG.TYP
   *
   * @param typ
   */
  @Override   public void setTyp( de.ivu.elect.business.email.entity.EmailVorgangType typ) {

       resetTkCache();
                  de.ivu.elect.business.email.entity.EmailVorgangType typInternal = typ;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.typ
      , typInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedTyp |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("typ");
      }


      

       this.typ = typInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu EmailLayout
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "EMAIL_LAYOUT_ID", referencedColumnName="EMAIL_LAYOUT_ID"))
  protected de.ivu.elect.business.email.entity.EmailLayout emailLayout;

  /**
   * 
   */
  @Override
  public void setEmailLayout(@javax.annotation.Nullable  de.ivu.elect.business.email.entity.EmailLayout emailLayout){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.emailLayout
    , emailLayout);

    attributeChanged |= thisAttributChanged;

    hasChangedEmailLayout |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("emailLayout");
    }

    this.emailLayout = emailLayout;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.email.entity.EmailLayout getEmailLayout(){
    return this.emailLayout;
  }

  @javax.persistence.Transient
  protected boolean hasChangedEmailLayout = false;

  public boolean hasChangedEmailLayout(){
    return hasChangedEmailLayout;
  }

  /**
   * Beziehung (unidirektional) zu EmailVorlage
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "EMAIL_VORLAGE_ID", referencedColumnName="EMAIL_VORLAGE_ID"))
  protected de.ivu.elect.business.email.entity.EmailVorlage emailVorlage;

  /**
   * 
   */
  @Override
  public void setEmailVorlage(@javax.annotation.Nullable  de.ivu.elect.business.email.entity.EmailVorlage emailVorlage){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.emailVorlage
    , emailVorlage);

    attributeChanged |= thisAttributChanged;

    hasChangedEmailVorlage |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("emailVorlage");
    }

    this.emailVorlage = emailVorlage;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.email.entity.EmailVorlage getEmailVorlage(){
    return this.emailVorlage;
  }

  @javax.persistence.Transient
  protected boolean hasChangedEmailVorlage = false;

  public boolean hasChangedEmailVorlage(){
    return hasChangedEmailVorlage;
  }

  /**
   * Beziehung (unidirektional) zu Wahltermin
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLTERMIN_ID", referencedColumnName="WAHLTERMIN_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahltermin wahltermin;

  /**
   * 
   */
  @Override
  public void setWahltermin( de.ivu.elect.business.wahl.entity.Wahltermin wahltermin){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahltermin
    , wahltermin);

    attributeChanged |= thisAttributChanged;

    hasChangedWahltermin |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahltermin");
    }

    this.wahltermin = wahltermin;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.wahl.entity.Wahltermin getWahltermin(){
    return this.wahltermin;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahltermin = false;

  public boolean hasChangedWahltermin(){
    return hasChangedWahltermin;
  }

  /**
   * Beziehung (unidirektional) zu Wahl
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=true, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHL_ID", referencedColumnName="WAHL_ID"))
  protected de.ivu.elect.business.wahl.entity.Wahl wahl;

  /**
   * 
   */
  @Override
  public void setWahl(@javax.annotation.Nullable  de.ivu.elect.business.wahl.entity.Wahl wahl){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahl
    , wahl);

    attributeChanged |= thisAttributChanged;

    hasChangedWahl |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahl");
    }

    this.wahl = wahl;
      }

  /**
   * 
   */
  @javax.annotation.Nullable   @Override
  public de.ivu.elect.business.wahl.entity.Wahl getWahl(){
    return this.wahl;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahl = false;

  public boolean hasChangedWahl(){
    return hasChangedWahl;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("EmailVorgang:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(EmailVorgang other){
                             other.benutzerkennung = this.benutzerkennung;
                                other.betreff = this.betreff;
                                other.erstellungszeitpunkt = this.erstellungszeitpunkt;
                                other.inhalt = this.inhalt;
                                other.status = this.status;
                                other.typ = this.typ;
           
  other.setEmailLayout(this.getEmailLayout());
  other.setEmailVorlage(this.getEmailVorlage());
  other.setWahltermin(this.getWahltermin());
  other.setWahl(this.getWahl());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(EmailVorgang.class)){
        copyEntityAttributesUsingSetter((EmailVorgang) other.castTo(EmailVorgang.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von EmailVorgang: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(EmailVorgang other){
               other.setBenutzerkennung(this.benutzerkennung);
                  other.setBetreff(this.betreff);
                  other.setErstellungszeitpunkt(this.erstellungszeitpunkt);
                  other.setInhalt(this.inhalt);
                  other.setStatus(this.status);
                  other.setTyp(this.typ);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(EmailVorgang other){
                       if (hasChangedBenutzerkennung) {
        other.setBenutzerkennung(this.benutzerkennung);
      }
                             if (hasChangedBetreff) {
        other.setBetreff(this.betreff);
      }
                             if (hasChangedErstellungszeitpunkt) {
        other.setErstellungszeitpunkt(this.erstellungszeitpunkt);
      }
                             if (hasChangedInhalt) {
        other.setInhalt(this.inhalt);
      }
                             if (hasChangedStatus) {
        other.setStatus(this.status);
      }
                             if (hasChangedTyp) {
        other.setTyp(this.typ);
      }
             }





    @javax.persistence.Transient
    private transient EmailVorgangTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public EmailVorgangTK getEmailVorgangTK(){
    if (tkCache==null) {
    tkCache = new EmailVorgangTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getEmailVorgangTK();
    }

  @Override
  public EmailVorgangUK getUk(){
    return getEmailVorgangUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return EmailVorgang.class;
  }

public EmailVorgangUK getEmailVorgangUK(){

   return  new EmailVorgangUK(



  );
}

  @javax.persistence.Transient
  private transient EmailVorgangProperties properties;

  public EmailVorgangProperties getProperties(){
    if (properties == null) {
      properties = new EmailVorgangProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public EmailVorgangProperties getEmailVorgangProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return EmailVorgangConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                                                         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                                                                                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                                                                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                                            return result;
  }

        
            protected String getInitialDiscriminator() {
              return "EMAIL_VORGANG";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "EmailVorgang";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

  @javax.persistence.Transient
  private transient boolean hashCodeBerechnet = false;

  @javax.persistence.Transient
  private transient int hashCode = 0;


  @Deprecated // nur in Unit-Tests verwenden(!)
  public void resetHashCode() {
    hashCodeBerechnet = false;
    hashCode = 0;
  }

  @Override
    public int hashCode() {
      if (hashCodeBerechnet) {
      return hashCode;
    }

    if (id == null) {
      hashCode = super.hashCode();
    } else {
      hashCode = id.hashCode();
    }

    hashCodeBerechnet = true;

    return hashCode;

    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailVorgangConstants.BENUTZERKENNUNG_MAX_LENGTH ,  benutzerkennung, this, EmailVorgangConstants.MESSAGE_KEY_BENUTZERKENNUNG_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(betreff, this, EmailVorgangConstants.MESSAGE_KEY_BETREFF_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailVorgangConstants.BETREFF_MAX_LENGTH , 1 ,  betreff, this, EmailVorgangConstants.MESSAGE_KEY_BETREFF_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(erstellungszeitpunkt, this, EmailVorgangConstants.MESSAGE_KEY_ERSTELLUNGSZEITPUNKT_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(inhalt, this, EmailVorgangConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(EmailVorgangConstants.INHALT_MAX_LENGTH , 1 ,  inhalt, this, EmailVorgangConstants.MESSAGE_KEY_INHALT_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(status, this, EmailVorgangConstants.MESSAGE_KEY_STATUS_EINZAHL, validationResult);
                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(typ, this, EmailVorgangConstants.MESSAGE_KEY_TYP_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        @Override
        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }
                              }
